require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_HIGHUID_H)) {
    eval 'sub _LINUX_HIGHUID_H {1;}' unless defined(&_LINUX_HIGHUID_H);
    require 'linux/types.ph';
    eval 'sub DEFAULT_OVERFLOWUID {65534;}' unless defined(&DEFAULT_OVERFLOWUID);
    eval 'sub DEFAULT_OVERFLOWGID {65534;}' unless defined(&DEFAULT_OVERFLOWGID);
    if(defined(&CONFIG_UID16)) {
	eval 'sub high2lowuid {
	    my($uid) = @_;
    	    eval q((($uid) & ~0xffff ? ( &old_uid_t) &overflowuid : ( &old_uid_t)($uid)));
	}' unless defined(&high2lowuid);
	eval 'sub high2lowgid {
	    my($gid) = @_;
    	    eval q((($gid) & ~0xffff ? ( &old_gid_t) &overflowgid : ( &old_gid_t)($gid)));
	}' unless defined(&high2lowgid);
	eval 'sub low2highuid {
	    my($uid) = @_;
    	    eval q((($uid) == ( &old_uid_t)-1? ( &uid_t)-1: ( &uid_t)($uid)));
	}' unless defined(&low2highuid);
	eval 'sub low2highgid {
	    my($gid) = @_;
    	    eval q((($gid) == ( &old_gid_t)-1? ( &gid_t)-1: ( &gid_t)($gid)));
	}' unless defined(&low2highgid);
	eval 'sub __convert_uid {
	    my($size, $uid) = @_;
    	    eval q(($size >= $sizeof{$uid} ? ($uid) :  &high2lowuid($uid)));
	}' unless defined(&__convert_uid);
	eval 'sub __convert_gid {
	    my($size, $gid) = @_;
    	    eval q(($size >= $sizeof{$gid} ? ($gid) :  &high2lowgid($gid)));
	}' unless defined(&__convert_gid);
    } else {
	eval 'sub __convert_uid {
	    my($size, $uid) = @_;
    	    eval q(($uid));
	}' unless defined(&__convert_uid);
	eval 'sub __convert_gid {
	    my($size, $gid) = @_;
    	    eval q(($gid));
	}' unless defined(&__convert_gid);
    }
    eval 'sub SET_UID {
        my($var, $uid) = @_;
	    eval q( &do { ($var) =  &__convert_uid($sizeof{$var}, ($uid)); }  &while (0));
    }' unless defined(&SET_UID);
    eval 'sub SET_GID {
        my($var, $gid) = @_;
	    eval q( &do { ($var) =  &__convert_gid($sizeof{$var}, ($gid)); }  &while (0));
    }' unless defined(&SET_GID);
    eval 'sub DEFAULT_FS_OVERFLOWUID {65534;}' unless defined(&DEFAULT_FS_OVERFLOWUID);
    eval 'sub DEFAULT_FS_OVERFLOWGID {65534;}' unless defined(&DEFAULT_FS_OVERFLOWGID);
    eval 'sub fs_high2lowuid {
        my($uid) = @_;
	    eval q((($uid) & ~0xffff ? ( &uid16_t) &fs_overflowuid : ( &uid16_t)($uid)));
    }' unless defined(&fs_high2lowuid);
    eval 'sub fs_high2lowgid {
        my($gid) = @_;
	    eval q((($gid) & ~0xffff ? ( &gid16_t) &fs_overflowgid : ( &gid16_t)($gid)));
    }' unless defined(&fs_high2lowgid);
    eval 'sub low_16_bits {
        my($x) = @_;
	    eval q((($x) & 0xffff));
    }' unless defined(&low_16_bits);
    eval 'sub high_16_bits {
        my($x) = @_;
	    eval q(((($x) & 0xffff0000) >> 16));
    }' unless defined(&high_16_bits);
}
1;
