require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_INOTIFY_H)) {
    eval 'sub _LINUX_INOTIFY_H {1;}' unless defined(&_LINUX_INOTIFY_H);
    require 'linux/types.ph';
    eval 'sub IN_ACCESS {0x1;}' unless defined(&IN_ACCESS);
    eval 'sub IN_MODIFY {0x2;}' unless defined(&IN_MODIFY);
    eval 'sub IN_ATTRIB {0x4;}' unless defined(&IN_ATTRIB);
    eval 'sub IN_CLOSE_WRITE {0x8;}' unless defined(&IN_CLOSE_WRITE);
    eval 'sub IN_CLOSE_NOWRITE {0x10;}' unless defined(&IN_CLOSE_NOWRITE);
    eval 'sub IN_OPEN {0x20;}' unless defined(&IN_OPEN);
    eval 'sub IN_MOVED_FROM {0x40;}' unless defined(&IN_MOVED_FROM);
    eval 'sub IN_MOVED_TO {0x80;}' unless defined(&IN_MOVED_TO);
    eval 'sub IN_CREATE {0x100;}' unless defined(&IN_CREATE);
    eval 'sub IN_DELETE {0x200;}' unless defined(&IN_DELETE);
    eval 'sub IN_DELETE_SELF {0x400;}' unless defined(&IN_DELETE_SELF);
    eval 'sub IN_MOVE_SELF {0x800;}' unless defined(&IN_MOVE_SELF);
    eval 'sub IN_UNMOUNT {0x2000;}' unless defined(&IN_UNMOUNT);
    eval 'sub IN_Q_OVERFLOW {0x4000;}' unless defined(&IN_Q_OVERFLOW);
    eval 'sub IN_IGNORED {0x8000;}' unless defined(&IN_IGNORED);
    eval 'sub IN_CLOSE {( &IN_CLOSE_WRITE |  &IN_CLOSE_NOWRITE);}' unless defined(&IN_CLOSE);
    eval 'sub IN_MOVE {( &IN_MOVED_FROM |  &IN_MOVED_TO);}' unless defined(&IN_MOVE);
    eval 'sub IN_ONLYDIR {0x1000000;}' unless defined(&IN_ONLYDIR);
    eval 'sub IN_DONT_FOLLOW {0x2000000;}' unless defined(&IN_DONT_FOLLOW);
    eval 'sub IN_MASK_ADD {0x20000000;}' unless defined(&IN_MASK_ADD);
    eval 'sub IN_ISDIR {0x40000000;}' unless defined(&IN_ISDIR);
    eval 'sub IN_ONESHOT {0x80000000;}' unless defined(&IN_ONESHOT);
    eval 'sub IN_ALL_EVENTS {( &IN_ACCESS |  &IN_MODIFY |  &IN_ATTRIB |  &IN_CLOSE_WRITE |  &IN_CLOSE_NOWRITE |  &IN_OPEN |  &IN_MOVED_FROM |  &IN_MOVED_TO |  &IN_DELETE |  &IN_CREATE |  &IN_DELETE_SELF |  &IN_MOVE_SELF);}' unless defined(&IN_ALL_EVENTS);
    if(defined(&__KERNEL__)) {
	require 'linux/dcache.ph';
	require 'linux/fs.ph';
	if(defined(&CONFIG_INOTIFY)) {
	} else {
	    eval 'sub inotify_d_instantiate {
	        my($dentry,$inode) = @_;
    		eval q({ });
	    }' unless defined(&inotify_d_instantiate);
	    eval 'sub inotify_d_move {
	        my($dentry) = @_;
    		eval q({ });
	    }' unless defined(&inotify_d_move);
	    eval 'sub inotify_inode_queue_event {
	        my($inode,$mask,$cookie,$filename,$n_inode) = @_;
    		eval q({ });
	    }' unless defined(&inotify_inode_queue_event);
	    eval 'sub inotify_dentry_parent_queue_event {
	        my($dentry,$mask,$cookie,$filename) = @_;
    		eval q({ });
	    }' unless defined(&inotify_dentry_parent_queue_event);
	    eval 'sub inotify_unmount_inodes {
	        my($list) = @_;
    		eval q({ });
	    }' unless defined(&inotify_unmount_inodes);
	    eval 'sub inotify_inode_is_dead {
	        my($inode) = @_;
    		eval q({ });
	    }' unless defined(&inotify_inode_is_dead);
	    eval 'sub inotify_get_cookie {
	        my($void) = @_;
    		eval q({ 0; });
	    }' unless defined(&inotify_get_cookie);
	    eval 'sub inotify_handle {
	        eval q(* &inotify_init( &const \'struct inotify_operations\' * &ops) {  &ERR_PTR(- &EOPNOTSUPP); });
	    }' unless defined(&inotify_handle);
	    eval 'sub inotify_init_watch {
	        my($watch) = @_;
    		eval q({ });
	    }' unless defined(&inotify_init_watch);
	    eval 'sub inotify_destroy {
	        my($ih) = @_;
    		eval q({ });
	    }' unless defined(&inotify_destroy);
	    eval 'sub inotify_find_watch {
	        my($ih,$inode,$watchp) = @_;
    		eval q({ - &EOPNOTSUPP; });
	    }' unless defined(&inotify_find_watch);
	    eval 'sub inotify_find_update_watch {
	        my($ih,$inode,$mask) = @_;
    		eval q({ - &EOPNOTSUPP; });
	    }' unless defined(&inotify_find_update_watch);
	    eval 'sub inotify_add_watch {
	        my($ih,$watch,$inode,$mask) = @_;
    		eval q({ - &EOPNOTSUPP; });
	    }' unless defined(&inotify_add_watch);
	    eval 'sub inotify_rm_watch {
	        my($ih,$watch) = @_;
    		eval q({ - &EOPNOTSUPP; });
	    }' unless defined(&inotify_rm_watch);
	    eval 'sub inotify_rm_wd {
	        my($ih,$wd) = @_;
    		eval q({ - &EOPNOTSUPP; });
	    }' unless defined(&inotify_rm_wd);
	    eval 'sub inotify_remove_watch_locked {
	        my($ih,$watch) = @_;
    		eval q({ });
	    }' unless defined(&inotify_remove_watch_locked);
	    eval 'sub get_inotify_watch {
	        my($watch) = @_;
    		eval q({ });
	    }' unless defined(&get_inotify_watch);
	    eval 'sub put_inotify_watch {
	        my($watch) = @_;
    		eval q({ });
	    }' unless defined(&put_inotify_watch);
	}
    }
}
1;
