require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_TRACE_IRQFLAGS_H)) {
    eval 'sub _LINUX_TRACE_IRQFLAGS_H {1;}' unless defined(&_LINUX_TRACE_IRQFLAGS_H);
    if(defined(&CONFIG_TRACE_IRQFLAGS)) {
	eval 'sub trace_hardirq_context {
	    my($p) = @_;
    	    eval q((($p)-> &hardirq_context));
	}' unless defined(&trace_hardirq_context);
	eval 'sub trace_softirq_context {
	    my($p) = @_;
    	    eval q((($p)-> &softirq_context));
	}' unless defined(&trace_softirq_context);
	eval 'sub trace_hardirqs_enabled {
	    my($p) = @_;
    	    eval q((($p)-> &hardirqs_enabled));
	}' unless defined(&trace_hardirqs_enabled);
	eval 'sub trace_softirqs_enabled {
	    my($p) = @_;
    	    eval q((($p)-> &softirqs_enabled));
	}' unless defined(&trace_softirqs_enabled);
	eval 'sub trace_hardirq_enter () {
	    eval q( &do {  ($current->{hardirq_context})++; }  &while (0));
	}' unless defined(&trace_hardirq_enter);
	eval 'sub trace_hardirq_exit () {
	    eval q( &do {  ($current->{hardirq_context})--; }  &while (0));
	}' unless defined(&trace_hardirq_exit);
	eval 'sub trace_softirq_enter () {
	    eval q( &do {  ($current->{softirq_context})++; }  &while (0));
	}' unless defined(&trace_softirq_enter);
	eval 'sub trace_softirq_exit () {
	    eval q( &do {  ($current->{softirq_context})--; }  &while (0));
	}' unless defined(&trace_softirq_exit);
	eval 'sub INIT_TRACE_IRQFLAGS {. &softirqs_enabled = 1,;}' unless defined(&INIT_TRACE_IRQFLAGS);
    } else {
	eval 'sub trace_hardirqs_on () {
	    eval q( &do { }  &while (0));
	}' unless defined(&trace_hardirqs_on);
	eval 'sub trace_hardirqs_off () {
	    eval q( &do { }  &while (0));
	}' unless defined(&trace_hardirqs_off);
	eval 'sub trace_softirqs_on {
	    my($ip) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&trace_softirqs_on);
	eval 'sub trace_softirqs_off {
	    my($ip) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&trace_softirqs_off);
	eval 'sub trace_hardirq_context {
	    my($p) = @_;
    	    eval q(0);
	}' unless defined(&trace_hardirq_context);
	eval 'sub trace_softirq_context {
	    my($p) = @_;
    	    eval q(0);
	}' unless defined(&trace_softirq_context);
	eval 'sub trace_hardirqs_enabled {
	    my($p) = @_;
    	    eval q(0);
	}' unless defined(&trace_hardirqs_enabled);
	eval 'sub trace_softirqs_enabled {
	    my($p) = @_;
    	    eval q(0);
	}' unless defined(&trace_softirqs_enabled);
	eval 'sub trace_hardirq_enter () {
	    eval q( &do { }  &while (0));
	}' unless defined(&trace_hardirq_enter);
	eval 'sub trace_hardirq_exit () {
	    eval q( &do { }  &while (0));
	}' unless defined(&trace_hardirq_exit);
	eval 'sub trace_softirq_enter () {
	    eval q( &do { }  &while (0));
	}' unless defined(&trace_softirq_enter);
	eval 'sub trace_softirq_exit () {
	    eval q( &do { }  &while (0));
	}' unless defined(&trace_softirq_exit);
	eval 'sub INIT_TRACE_IRQFLAGS {1;}' unless defined(&INIT_TRACE_IRQFLAGS);
    }
    if(defined(&CONFIG_TRACE_IRQFLAGS_SUPPORT)) {
	require 'asm/irqflags.ph';
	eval 'sub local_irq_enable () {
	    eval q( &do {  &trace_hardirqs_on();  &raw_local_irq_enable(); }  &while (0));
	}' unless defined(&local_irq_enable);
	eval 'sub local_irq_disable () {
	    eval q( &do {  &raw_local_irq_disable();  &trace_hardirqs_off(); }  &while (0));
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_save {
	    my($flags) = @_;
    	    eval q( &do {  &raw_local_irq_save($flags);  &trace_hardirqs_off(); }  &while (0));
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_restore {
	    my($flags) = @_;
    	    eval q( &do {  &if ( &raw_irqs_disabled_flags($flags)) {  &raw_local_irq_restore($flags);  &trace_hardirqs_off(); }  &else {  &trace_hardirqs_on();  &raw_local_irq_restore($flags); } }  &while (0));
	}' unless defined(&local_irq_restore);
    } else {
	eval 'sub raw_local_irq_disable () {
	    eval q( &local_irq_disable());
	}' unless defined(&raw_local_irq_disable);
	eval 'sub raw_local_irq_enable () {
	    eval q( &local_irq_enable());
	}' unless defined(&raw_local_irq_enable);
	eval 'sub raw_local_irq_save {
	    my($flags) = @_;
    	    eval q( &local_irq_save($flags));
	}' unless defined(&raw_local_irq_save);
	eval 'sub raw_local_irq_restore {
	    my($flags) = @_;
    	    eval q( &local_irq_restore($flags));
	}' unless defined(&raw_local_irq_restore);
    }
    if(defined(&CONFIG_TRACE_IRQFLAGS_SUPPORT)) {
	eval 'sub safe_halt () {
	    eval q( &do {  &trace_hardirqs_on();  &raw_safe_halt(); }  &while (0));
	}' unless defined(&safe_halt);
	eval 'sub local_save_flags {
	    my($flags) = @_;
    	    eval q( &raw_local_save_flags($flags));
	}' unless defined(&local_save_flags);
	eval 'sub irqs_disabled () {
	    eval q(({ \'unsigned long flags\';  &raw_local_save_flags( &flags);  &raw_irqs_disabled_flags( &flags); }));
	}' unless defined(&irqs_disabled);
	eval 'sub irqs_disabled_flags {
	    my($flags) = @_;
    	    eval q( &raw_irqs_disabled_flags($flags));
	}' unless defined(&irqs_disabled_flags);
    }
}
1;
