require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_TASKSTATS_KERN_H)) {
    eval 'sub _LINUX_TASKSTATS_KERN_H {1;}' unless defined(&_LINUX_TASKSTATS_KERN_H);
    require 'linux/taskstats.ph';
    require 'linux/sched.ph';
    require 'net/genetlink.ph';
    if(defined(&CONFIG_TASKSTATS)) {
	eval 'sub taskstats_exit_free {
	    my($tidstats) = @_;
    	    eval q({  &if ($tidstats)  &kmem_cache_free( &taskstats_cache, $tidstats); });
	}' unless defined(&taskstats_exit_free);
	eval 'sub taskstats_tgid_init {
	    my($sig) = @_;
    	    eval q({  &spin_lock_init( ($sig->{stats_lock}));  ($sig->{stats}) =  &NULL; });
	}' unless defined(&taskstats_tgid_init);
	eval 'sub taskstats_tgid_alloc {
	    my($sig) = @_;
    	    eval q({ \'struct taskstats\' * &stats; my $flags;  &stats =  &kmem_cache_zalloc( &taskstats_cache,  &SLAB_KERNEL);  &if (! &stats) ;  &spin_lock_irqsave( ($sig->{stats_lock}),  $flags);  &if (! ($sig->{stats})) {  ($sig->{stats}) =  &stats;  &stats =  &NULL; }  &spin_unlock_irqrestore( ($sig->{stats_lock}),  $flags);  &if ( &stats)  &kmem_cache_free( &taskstats_cache,  &stats); });
	}' unless defined(&taskstats_tgid_alloc);
	eval 'sub taskstats_tgid_free {
	    my($sig) = @_;
    	    eval q({ \'struct taskstats\' * &stats =  &NULL; my $flags;  &spin_lock_irqsave( ($sig->{stats_lock}),  $flags);  &if ( ($sig->{stats})) {  &stats =  ($sig->{stats});  ($sig->{stats}) =  &NULL; }  &spin_unlock_irqrestore( ($sig->{stats_lock}),  $flags);  &if ( &stats)  &kmem_cache_free( &taskstats_cache,  &stats); });
	}' unless defined(&taskstats_tgid_free);
    } else {
	eval 'sub taskstats_exit_alloc {
	    my($ptidstats,$mycpu) = @_;
    	    eval q({});
	}' unless defined(&taskstats_exit_alloc);
	eval 'sub taskstats_exit_free {
	    my($ptidstats) = @_;
    	    eval q({});
	}' unless defined(&taskstats_exit_free);
	eval 'sub taskstats_exit_send {
	    my($tsk,$tidstats,$group_dead,$cpu) = @_;
    	    eval q({});
	}' unless defined(&taskstats_exit_send);
	eval 'sub taskstats_tgid_init {
	    my($sig) = @_;
    	    eval q({});
	}' unless defined(&taskstats_tgid_init);
	eval 'sub taskstats_tgid_alloc {
	    my($sig) = @_;
    	    eval q({});
	}' unless defined(&taskstats_tgid_alloc);
	eval 'sub taskstats_tgid_free {
	    my($sig) = @_;
    	    eval q({});
	}' unless defined(&taskstats_tgid_free);
	eval 'sub taskstats_init_early {
	    my($void) = @_;
    	    eval q({});
	}' unless defined(&taskstats_init_early);
    }
}
1;
